package example.energy.coolemall;

import schedframe.resources.StandardResourceType;
import schedframe.resources.computing.ComputingResource;
import schedframe.resources.computing.Node;
import schedframe.resources.computing.Processor;
import schedframe.resources.computing.profiles.energy.ResourceEvent;
import schedframe.resources.computing.profiles.energy.power.StandardPowerStateName;
import schedframe.resources.devices.Device;
import schedframe.resources.devices.Fan;
import schedframe.resources.devices.PhysicalResource;
import schedframe.scheduling.manager.tasks.JobRegistry;
import example.energy.BaseEnergyEstimationPlugin;

public class NodeEnergyEstimationPlugin extends BaseEnergyEstimationPlugin {

	public double estimatePowerConsumption(ResourceEvent event, JobRegistry jobRegistry,
			PhysicalResource resource) {
		double powerConsumption = 0;
		Node node = (Node) resource;
		for(Processor cpu: node.getProcessors()){
			try{
				powerConsumption = powerConsumption + cpu.getPowerInterface().getRecentPowerUsage().getValue();
			} catch (Exception e){
				
			}
		}
		if(node.getPowerInterface().getPowerState().equals(StandardPowerStateName.ON)){
			//powerConsumption = powerConsumption + CoolEmAllTestbedMeasurements.SINGLE_FAN_ON_POWER_CONSUMPTION;
			for(Device device: node.getParent().getResourceCharacteristic().getDevices()){
				if(device.getType().equals(StandardResourceType.Fan) || device.getType().equals(StandardResourceType.Inlet) | device.getType().equals(StandardResourceType.Outlet)){
					Fan fan = (Fan) device;
					if(fan.getChilledResources().contains(node.getFullName())){
						if(fan.getPowerInterface().getRecentPowerUsage().getValue() == -1){
							try {
								powerConsumption = powerConsumption + fan.getAirflowInterface().getPowerConsumption(fan.getAirflowInterface().getAirflowState())/(double)fan.getChilledResources().size();
							} catch (NoSuchFieldException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
						}else
							powerConsumption = powerConsumption + fan.getPowerInterface().getRecentPowerUsage().getValue()/getNumberOfWorkingNodes(fan);
					}
				}
			}
		} 

		return powerConsumption;
	}
	
	
	private int getNumberOfWorkingNodes(Device device){
		int quantity = 0;
		Fan fan = (Fan) device;
		for(ComputingResource compRes: device.getComputingResource().getChildren()){
			Node node = (Node)compRes;
			if(node.getPowerInterface().getPowerState().equals(StandardPowerStateName.ON) && fan.getChilledResources().contains(node.getFullName())){
				quantity++;
			}
		}
		return quantity;
	}

}
